# Copyright (c) 2013, University of Bristol and University of Southampton.

from EStat.Templating import Template

class TemplateCompleteCases(Template):
    'Removes rows with missing'

    __version__ = '1.0.0'

    tags = [ 'Data manipulation']
    engines = ['Python_script']

    inputs = '''
vars = DataMatrix('Variables to include: ')
outdata=Text('Name of output dataset: ')
'''

    pythonscript = '''
import numpy

import EStat
from EStat.Templating import *
from EStat.DTAFile import DTAFile

filter = [True] * datafile.nobs
for var in vars:
    filter = filter & ~datafile.variables[var]['data'].mask

retval = datafile.copy()
retval.nobs = len(filter[filter == True])

for k in datafile.variables.keys():
    if k in vars:
        retval.variables[k]['data'] = retval.variables[k]['data'][numpy.array(filter)]
    else:
        del retval.variables[k]

#datalist = numpy.ma.empty((datafile.nobs, datafile.nvar))
#for i, k in enumerate(datafile.variables.keys()):
#    datalist[:, i] = datafile.variables[k]['data']

#datalist = numpy.ma.compress_rows(datalist)

#retval = datafile.copy()
#retval.nobs = len(datalist)

# Copy data back
#for i, k in enumerate(datafile.variables.keys()):
#    retval.variables[k]['data'] = numpy.ma.array(datalist[:, i], mask = [False for row in range(len(datalist))])

outputs[str(outdata)] = retval
'''
